# Here I import some useful libraries 
import urllib2    
import re
import shapefile

# Here I open a .shp file to read what are the platforms I need for the simulation
sf = shapefile.Reader("Bike_docking_stations.shp")
shapes = sf.shapes()
fields = sf.fields
records = sf.records()

# Here I create a string for each platform composed by two parts: the name of the platform itself plus some characters that
# are useful in order to identify in the HTML page just one single result by means of searching
platforms = []
for i in range (len(shapes)):
      platforms.append('>'+str(records[i][2])+'</span>')

# Here I open the URL and look for the previous items. Then I associate each platform I am interested in it, with its
# correspondent ID number that compares in the website.
my_number = []
not_reported = []
f = urllib2.urlopen('http://www.tobike.it/frmLeStazioni.aspx') 

for line in f:
    for j in range (len(shapes)): 
        if re.search(platforms[j], line):
            splitt = line.split('_i')
            Splitt = splitt[1].split('_')
            my_number.append(int(Splitt[0]))     

# It associates the _i HTML number to the name of the Platform
f = urllib2.urlopen('http://www.tobike.it/frmLeStazioni.aspx')   
association = []
n = 0
for line in f:
 for i in my_number:
   if re.search('<span id="wcPGoogle_radRotStazioni_i'+str(i)+'_Laber22" class="Stazione">', line):
      couple = []   
      lstrip = line.lstrip()
      lsplitted = lstrip.split('</span>')
      lSplitted = lsplitted[0].split('>')
      couple.append(i)
      couple.append(lSplitted[1])
      association.append(couple) 
f.close()

w_i_p = []
for i in range (len(records)):
   t = 0
   for j in range (len(association)):
      if str(records[i][2]) == str(association[j][1]):
        t = 1
   if t == 0:
      w_i_p.append(str(records[i][2]))

work_in_progress = []      
for i in range (len(w_i_p)):
      work_in_progress.append('>'+str(w_i_p[i])+'<br><strong>')
      
f = urllib2.urlopen('http://www.tobike.it/frmLeStazioni.aspx')   
for line in f:
    for j in range (len(w_i_p)): 
        if re.search(work_in_progress[j], line):
            splitt = line.split('_i')
            Splitt = splitt[1].split('_')
            my_number.append(int(Splitt[0]))     
f.close()
my_number.sort()

#It just needs to show that the program is working well
print ("La prima meta' del programma e' stata eseguita con successo.")
print ('Python ha aggiornato lo stato del TO-Bike.')
print ("N.B. non e' stato possibile aggiornare "+str(len(shapes)-len(my_number))+" postazione/i.")
print ('')

# Here starts the 2nd part of the program, it reads the status of that platforms I am interested in and reports
# their situations
f = urllib2.urlopen('http://www.tobike.it/frmLeStazioni.aspx')   
lines = []
for line in f:
 for i in my_number:
   if re.search('<span id="wcPGoogle_radRotStazioni_i'+str(i)+'_label23" class="Red">', line):
      lstrip = line.lstrip()
      lsplitted = lstrip.split('<br>')
      lines.append(lsplitted)
f.close()

# The following two blocks only fix the content of my list of vectors by 
for i in range(len(lines)):
 last_to_add = lines[i][len(lines[i])-1].split('<')
 last = lines[i][len(lines[i])-1]
 lines[i].remove(last)
 lines[i].append(last_to_add[0])
 
for i in range(len(lines)):
 first_to_add = lines[i][0].split('>')
 first = lines[i][0]
 lines[i].reverse()
 lines[i].remove(first)
 lines[i].append(first_to_add[1])
 lines[i].reverse()

# It converts the the content of lines to a list of numbers
numbers = []
for i in range(len(lines)):
  for j in range(len(lines[i])):
    myString = str(lines[i][j])
    result = re.match('\d+', myString)
    if result != None:
     numbers.append(int(result.group()))
    # print(result.group())
  if len(lines[i]) != 3:
   numbers.append(int(0))
  
# Read in our existing shapefile
r = shapefile.Reader("Bike_docking_stations.shp")

# Create a new shapefile in memory
w = shapefile.Writer()

# Copy over the existing fields
w.fields = list(r.fields)

# Add our new field using the pyshp API
w.field("AVAILABLE_B","N","9")
w.field("AVAILABLE_P","N","9")
w.field("BROKEN_BIKE","N","9")

# Loop through each record, add a column.  We'll
# insert our sample data
i = 0
n = 0

for rec in r.records():
 for k in range (3):
    rec.append(numbers[n+k])
 if n < 3*(len(lines)-1):
    n = n + 3
 i = i + 1
 
# Add the modified record to the new shapefile 
 w.records.append(rec)

# Copy over the geometry without any changes
w._shapes.extend(r.shapes())
w.save("TO_Bike_actual_situation")

print("Il programma e' concluso.")
print("Ha generato un file .shp con i dati aggiornati.")
print("Alle postazioni mancanti sono stati attribuiti valori verosimili.")










 
